#ifndef IRRADIANCE_FIRST_H
#define IRRADIANCE_FIRST_H

#include "../src/shaders/shader.h"
#include "../src/shaders/pathshader.h"
#include "../src/core/IrradianceCacheRecord.h"
#include "../src/core/octree.h"
class Irradiance_First : public Shader
{
public:
    /*struct irradianceCacheRecord {
        Intersection its;//vector 3d 

        Vector3D color;//E
        double harmonicMean;
        int i;

        Vector3D point2D;
    };*/

private:

    Vector3D** data;
    std::vector<IrradianceCacheRecord> irradianceCache;

    octree irradianceCache2;

    PathShader path;

    int jump;
    int nSamplesHemis;
    bool show_points;
    bool indirectOnly;

public:
    Irradiance_First();
    Irradiance_First(Vector3D bgColor, size_t maxDepth, bool show_point, size_t nSamplesArea_, bool indirectOnly_, size_t nSamplesHemis_);

    Vector3D computeColor3D(const Ray& r, Scene& scene, size_t x, size_t y);

    virtual Vector3D computeColor(const Ray& r, Scene& scene)const;

    virtual void preprocess(Scene& scene);

    void computeRecord(size_t x, size_t y, size_t width_, size_t height_, Scene& scene, std::vector<Vector3D> displacementSamples,int i);
    void fillCache(size_t width_, size_t height_, Scene& scene);

    std::vector<Vector3D> displacementCalc( size_t width_, size_t height_);

    std::vector<IrradianceCacheRecord> near4Neighbour2D(size_t x, size_t y);
    std::vector<IrradianceCacheRecord> near_n_Neighbour(Intersection its,int n);
    virtual void render(Scene& scene);

    void harmonicMean(IrradianceCacheRecord& record, int numSamplesMean, Scene &scene);

    double computeHarmonic(Intersection its, Ray indirectRay, Scene& scene, int x, int y);


};

#endif // IRRADIANCE_FIRST_H
