#include "octree.h"
#include <iostream>

octree::octree() {

}
octree::octree(int depth_, Vector3D center, Vector3D topLeftBack, Vector3D botRightBack,int x, int y, int z) {
	main = new struct nodeTree();
	this->main->center = center;
	this->main->topLeftFront = topLeftBack;
	this->main->botRightBack = botRightBack;
	this->main->sizex = (double)x;
	this->main->sizey = (double)y;
	this->main->sizez = (double)z/2.0;
	depth = depth_;
	num = 0;
	octreeCreate(this->main,0);
}

void octree::octreeCreate(nodeTree* node, int n) {

	node->children[0] = new struct nodeTree;
	node->children[0]->topLeftFront = node->topLeftFront;
	Vector3D center(node->children[0]->topLeftFront.x + node->sizex / 2.0, node->children[0]->topLeftFront.y - node->sizey / 2.0, node->children[0]->topLeftFront.z + node->sizez / 2.0);
	node->children[0]->botRightBack = node->center;
	node->children[0]->center = center;
	node->children[0]->sizex = node->sizex / 2.0;
	node->children[0]->sizey = node->sizey / 2.0;
	node->children[0]->sizez = node->sizez / 2.0;

	Vector3D topLeftFront = Vector3D(node->topLeftFront.x + node->sizex, node->topLeftFront.y, node->topLeftFront.z);
	Vector3D botRightBack = Vector3D(node->center.x + node->sizex, node->center.y, node->center.z);
	node->children[1] = new struct nodeTree;
	node->children[1]->topLeftFront = topLeftFront;
	node->children[1]->botRightBack = botRightBack;
	center = Vector3D(node->children[1]->topLeftFront.x + node->sizex / 2.0, node->children[1]->topLeftFront.y - node->sizey / 2.0, node->children[1]->topLeftFront.z + node->sizez / 2.0);
	node->children[1]->center = center;
	node->children[1]->sizex = node->sizex / 2.0;
	node->children[1]->sizey = node->sizey / 2.0;
	node->children[1]->sizez = node->sizez / 2.0;

	topLeftFront = Vector3D(node->topLeftFront.x, node->topLeftFront.y - node->sizey, node->topLeftFront.z);
	botRightBack = Vector3D(node->center.x , node->center.y - node->sizey, node->center.z);
	node->children[2] = new struct nodeTree;
	node->children[2]->topLeftFront = topLeftFront;
	node->children[2]->botRightBack = botRightBack;
	center = Vector3D(node->children[2]->topLeftFront.x + node->sizex / 2.0, node->children[2]->topLeftFront.y - node->sizey / 2.0, node->children[2]->topLeftFront.z + node->sizez / 2.0);
	node->children[2]->center = center;
	node->children[2]->sizex = node->sizex / 2.0;
	node->children[2]->sizey = node->sizey / 2.0;
	node->children[2]->sizez = node->sizez / 2.0;

	topLeftFront = Vector3D(node->center.x, node->center.y , node->topLeftFront.z);
	botRightBack = Vector3D(node->center.x + node->sizex, node->center.y - node->sizey, node->center.z);
	node->children[3] = new struct nodeTree;
	node->children[3]->topLeftFront = topLeftFront;
	node->children[3]->botRightBack = botRightBack;
	center = Vector3D(node->children[3]->topLeftFront.x + node->sizex / 2.0, node->children[3]->topLeftFront.y - node->sizey / 2.0, node->children[3]->topLeftFront.z + node->sizez / 2.0);
	node->children[3]->center = center;
	node->children[3]->sizex = node->sizex / 2.0;
	node->children[3]->sizey = node->sizey / 2.0;
	node->children[3]->sizez = node->sizez / 2.0;

	topLeftFront = Vector3D(node->topLeftFront.x, node->topLeftFront.y, node->center.z);
	botRightBack = Vector3D(node->center.x, node->center.y, node->botRightBack.z);
	node->children[4] = new struct nodeTree;
	node->children[4]->topLeftFront = topLeftFront;
	node->children[4]->botRightBack = botRightBack;
	center = Vector3D(node->children[4]->topLeftFront.x + node->sizex / 2.0, node->children[4]->topLeftFront.y - node->sizey / 2.0, node->children[4]->topLeftFront.z + node->sizez / 2.0);
	node->children[4]->center = center;
	node->children[4]->sizex = node->sizex / 2.0;
	node->children[4]->sizey = node->sizey / 2.0;
	node->children[4]->sizez = node->sizez / 2.0;

	topLeftFront = Vector3D(node->center.x, node->center.y + node->sizey, node->center.z);
	botRightBack = Vector3D(node->center.x + node->sizex, node->center.y, node->botRightBack.z);
	node->children[5] = new struct nodeTree;
	node->children[5]->topLeftFront = topLeftFront;
	node->children[5]->botRightBack = botRightBack;
	center = Vector3D(node->children[5]->topLeftFront.x + node->sizex / 2.0, node->children[5]->topLeftFront.y - node->sizey / 2.0, node->children[5]->topLeftFront.z + node->sizez / 2.0);
	node->children[5]->center = center;
	node->children[5]->sizex = node->sizex / 2.0;
	node->children[5]->sizey = node->sizey / 2.0;
	node->children[5]->sizez = node->sizez / 2.0;

	topLeftFront = Vector3D(node->center.x - node->sizex, node->center.y, node->center.z);
	botRightBack = Vector3D(node->center.x , node->center.y - node->sizey, node->botRightBack.z);
	node->children[6] = new struct nodeTree;
	node->children[6]->topLeftFront = topLeftFront;
	node->children[6]->botRightBack = botRightBack;
	center = Vector3D(node->children[6]->topLeftFront.x + node->sizex / 2.0, node->children[6]->topLeftFront.y - node->sizey / 2.0, node->children[6]->topLeftFront.z + node->sizez / 2.0);
	node->children[6]->center = center;
	node->children[6]->sizex = node->sizex / 2.0;
	node->children[6]->sizey = node->sizey / 2.0;
	node->children[6]->sizez = node->sizez / 2.0;

	node->children[7] = new struct nodeTree;
	node->children[7]->topLeftFront = node->center;
	node->children[7]->botRightBack = node->botRightBack;
	center = Vector3D(node->children[7]->topLeftFront.x + node->sizex / 2.0, node->children[7]->topLeftFront.y - node->sizey / 2.0, node->children[7]->topLeftFront.z + node->sizez / 2.0);
	node->children[7]->center = center;
	node->children[7]->sizex = node->sizex / 2.0;
	node->children[7]->sizey = node->sizey / 2.0;
	node->children[7]->sizez = node->sizez / 2.0;

	if (n < depth) {
		n++;
		for (int i = 0; i < 8; i++) {
			octreeCreate(node->children[i], n);
		}
	}
}

void octree::pushRecord(IrradianceCacheRecord& record) {

	pushRecordRec(record, main,0);
}

bool octree::recordInNode(IrradianceCacheRecord& record, nodeTree* node) {
	if (record.its.itsPoint.x >= node->topLeftFront.x and record.its.itsPoint.y <= node->topLeftFront.y and record.its.itsPoint.z >= node->topLeftFront.z
		and record.its.itsPoint.x <= node->botRightBack.x and record.its.itsPoint.y >= node->botRightBack.y and record.its.itsPoint.z <= node->botRightBack.z) {
		//std::cout << "true" << std::endl;
		return true;
	}
	else {
		//std::cout << "false" << std::endl;
		return false;
	}
}

void octree::pushRecordRec(IrradianceCacheRecord& record, nodeTree* node,int n) {
	//std::cout << n << std::endl;
	if (n < depth) {
		if (recordInNode(record, node->children[0])) {
			n++;
			pushRecordRec(record, node->children[0], n);
		}
		else if (recordInNode(record, node->children[1])) {
			n++;
			pushRecordRec(record, node->children[1], n);
		}
		else if (recordInNode(record, node->children[2])) {
			n++;
			pushRecordRec(record, node->children[2], n);
		}
		else if (recordInNode(record, node->children[3])) {
			n++;
			pushRecordRec(record, node->children[3], n);
		}
		else if (recordInNode(record, node->children[4])) {
			n++;
			pushRecordRec(record, node->children[4], n);
		}
		else if (recordInNode(record, node->children[5])) {
			n++;
			pushRecordRec(record, node->children[5], n);
		}
		else if (recordInNode(record, node->children[6])) {
			n++;
			pushRecordRec(record, node->children[6], n);
		}
		else if (recordInNode(record, node->children[7])) {
			n++;
			pushRecordRec(record, node->children[7], n);
		}
	}
	else {
		//std::cout << "record push" << std::endl;
		node->records.push_back(record);
		num++;
	}
}

std::vector <IrradianceCacheRecord> octree::getRecordsOnOct(Vector3D point) {

	return getRecordsOnOctRec(point,this->main, 0);

}

std::vector <IrradianceCacheRecord> octree::getRecordsOnOctRec(Vector3D point, nodeTree* node, int n) {
	//std::cout << n << std::endl;
	if (n < depth) {
		if (vectorInNode(point, node->children[0])) {
			n++;
			return getRecordsOnOctRec(point, node->children[0], n);
		}
		else if (vectorInNode(point, node->children[1])) {
			n++;
			return getRecordsOnOctRec(point, node->children[1], n);
		}
		else if (vectorInNode(point, node->children[2])) {
			n++;
			return getRecordsOnOctRec(point, node->children[2], n);
		}
		else if (vectorInNode(point, node->children[3])) {
			n++;
			return getRecordsOnOctRec(point, node->children[3], n);
		}
		else if (vectorInNode(point, node->children[4])) {
			n++;
			return getRecordsOnOctRec(point, node->children[4], n);
		}
		else if (vectorInNode(point, node->children[5])) {
			n++;
			return getRecordsOnOctRec(point, node->children[5], n);
		}
		else if (vectorInNode(point, node->children[6])) {
			n++;
			return getRecordsOnOctRec(point, node->children[6], n);
		}
		else if (vectorInNode(point, node->children[7])) {
			n++;
			return getRecordsOnOctRec(point, node->children[7], n);
		}
	}
	//std::cout << "----" << std::endl;
	return node->records;
}

bool octree::vectorInNode(Vector3D point, nodeTree* node) {
	if (point.x >= node->topLeftFront.x and point.y <= node->topLeftFront.y and point.z >= node->topLeftFront.z
		and point.x <= node->botRightBack.x and point.y >= node->botRightBack.y and point.z <= node->botRightBack.z) {
		//std::cout << "true" << std::endl;
		return true;
	}
	else {
		return false;
	}
}