#ifndef octree_H
#define octree_H

#include "IrradianceCacheRecord.h"
#include <vector>
#include "vector3D.h"

class octree {

private:
	struct nodeTree {
		Vector3D center;
		Vector3D topLeftFront;
		Vector3D botRightBack;
		double sizey;
		double sizex;
		double sizez;
		struct nodeTree *children[8];
		//Irradiance_First::irradianceCacheRecord* record;
		std::vector<IrradianceCacheRecord> records;
	};

	struct nodeTree *main;
	int depth;

public:
	int num;

	octree();
	octree(int depth,Vector3D center,Vector3D topLeftBack, Vector3D botRightBack, int x, int y, int z);

	void octreeCreate(nodeTree *node,int n);

	void pushRecord(IrradianceCacheRecord& record);
	void pushRecordRec(IrradianceCacheRecord& record, nodeTree* node, int n);
	std::vector <IrradianceCacheRecord> getRecordsOnOct(Vector3D point);
	std::vector <IrradianceCacheRecord> getRecordsOnOctRec(Vector3D point, nodeTree* node, int n);

	bool recordInNode(IrradianceCacheRecord& record, nodeTree* node);
	bool vectorInNode(Vector3D point, nodeTree* node);

};

#endif // octree_H