#ifndef SCENE_H
#define SCENE_H

#include <ostream>
#include <fstream>

#include "../core/utils.h"
#include "../cameras/camera.h"
#include "../lightsources/lightsource.h"

class Shader;

class Scene
{
public:
	// public methods
	bool loadScene(const char* filename, Shader *&shader_out);
	bool getClosestIntersection(const Ray &cameraRay, Intersection &its);
	bool hasIntersection(const Ray &cameraRay);

	// Getters
	Camera & getCamera(); 

//private:
	Camera *cam;
	Shader *shader;
	std::vector<Shape*> *objectsList; 
	std::vector<Shape*> *areaLSList;
	std::vector<LightSource> *lightSourceList;
};

#endif // SCENE_H
