#include "texture.h"

#include <algorithm>

Texture::Texture(const Vector3D &val) :
    textureWidth(1), textureHeight(1)
{
    textureData = new Vector3D*[1];
    textureData[0] = new Vector3D(val);
}

Texture::Texture(std::string fileName_)
{
    BitMap::read(textureData, textureWidth, textureHeight, fileName_);
}

Vector3D Texture::getTextureValue(const double u, const double v) const
{
    // get the closest texel (nearest neighbour)
    size_t lin, col;
    lin = size_t((1.0-v) * (textureHeight-1));
    col = size_t(u * (textureWidth-1));

    return textureData[lin][col];

/*    // fetch a bilinearly filtered texel
    double fu = (a_U + 1000.5f) * m_Width;
    double fv = (a_V + 1000.0f) * m_Width;
    int u1 = ((int)fu) % m_Width;
    int v1 = ((int)fv) % m_Height;
    int u2 = (u1 + 1) % m_Width;
    int v2 = (v1 + 1) % m_Height;

    // calculate fractional parts of u and v
    double fracu = fu - floorf( fu );
    double fracv = fv - floorf( fv );

    // calculate weight factors
    double w1 = (1 - fracu) * (1 - fracv);
    double w2 = fracu * (1 - fracv);
    double w3 = (1 - fracu) * fracv;
    double w4 = fracu *  fracv;

    // fetch four texels
    Color c1 = m_Bitmap[u1 + v1 * m_Width];
    Color c2 = m_Bitmap[u2 + v1 * m_Width];
    Color c3 = m_Bitmap[u1 + v2 * m_Width];
    Color c4 = m_Bitmap[u2 + v2 * m_Width];

    // scale and sum the four colors
    return c1 * w1 + c2 * w2 + c3 * w3 + c4 * w4;
    */
}

Texture::~Texture()
{

}
