#ifndef TEXTURE_H
#define TEXTURE_H

#include "../core/bitmap.h"


class Texture
{
public:
    Texture() = delete;

    // Constant-valued texture constructor
    Texture(const Vector3D &val);

    // Constructor based on the file name to the texture image
    Texture(std::string fileName_);

    // Returns the texture value at the coordinates (u, v)
    Vector3D getTextureValue(const double u, const double v) const;

    ~Texture();

private:
    Vector3D** textureData;
    size_t textureWidth, textureHeight;
};

#endif // TEXTURE_H
