#include "lightsource.h"

// POINT LIGHT SOURCE (AREA LIGHTS ARE DEALT WITH IN THE SHAPES CLASS)

LightSource::LightSource(Vector3D pos_, Vector3D intensity_) :
    pos(pos_), intensity(intensity_)
{ }

Vector3D LightSource::getPosition() const
{
    return pos;
}

Vector3D LightSource::getRadiance(const Vector3D &p) const
{
    double sqDistance = (p - pos).lengthSq();

    Vector3D result = intensity / sqDistance;
    return result;
}

