#ifndef LIGHTSOURCE_H
#define LIGHTSOURCE_H

#include "../core/vector3d.h"

// POINT LIGHT SOURCE (AREA LIGHTS ARE DEALT WITH IN THE SHAPES CLASS)
class LightSource
{
public:
    LightSource() = delete;
    LightSource(Vector3D pos_, Vector3D intensity_);

    // Getters
    Vector3D getPosition() const;
    Vector3D getRadiance(const Vector3D &dir) const;


private:
    Vector3D pos;
    Vector3D intensity; // (unity: watts/sr)
};

#endif // LIGHTSOURCE_H
