#ifndef PHONG_H
#define PHONG_H

#include "../materials/material.h"
#include "../core/texture.h"

class Phong : public Material
{
public:
    Phong();
    Phong(Vector3D kd_, Vector3D ks_, double shininess_);
    Phong(std::string fileName_, double shininess_);

    virtual Vector3D getReflectance(const Vector3D &n, const Vector3D &wo, const Vector3D &wi,
                                    const double u, const double v) const;
    virtual bool hasSpecular() const;
    virtual bool hasTransmission() const;
    virtual bool hasDiffuseOrGlossy() const;

    ~Phong();

private:
    Texture *kdTexture;
    Texture *ksTexture;
    double shininess;
};

#endif // PHONG_H
