#include "transmissive.h"

Transmissive::Transmissive() :
    indexOfRefraction(1.2), color(Vector3D(1.0))
{

}

Transmissive::Transmissive(double indexOfRefraction_, Vector3D color_) :
    indexOfRefraction(indexOfRefraction_), color(color_)
{ }

Vector3D Transmissive::getReflectance(const Vector3D &n, const Vector3D &wo, const Vector3D &wi,
                                      const double u, const double v) const
{
    return color;
}

bool Transmissive::hasSpecular() const
{
    return true;
}

bool Transmissive::hasTransmission() const
{
    return true;
}

bool Transmissive::hasDiffuseOrGlossy() const
{
    return false;
}

double Transmissive::getIndexOfRefraction() const
{
    return indexOfRefraction;
}
