#ifndef TRANSMISSIVE_H
#define TRANSMISSIVE_H

#include "../materials/material.h"

class Transmissive : public Material
{
public:
    Transmissive();
    Transmissive(double indexOfRefraction_, Vector3D color_);

    virtual Vector3D getReflectance(const Vector3D &n, const Vector3D &wo, const Vector3D &wi,
                                    const double u, const double v) const;
    virtual bool hasSpecular() const;
    virtual bool hasTransmission() const;
    virtual bool hasDiffuseOrGlossy() const;
    virtual double getIndexOfRefraction() const;

private:
    double indexOfRefraction;
    Vector3D color;
};

#endif // TRANSMISSIVE_H
