#ifndef SHADER_H
#define SHADER_H

#include <vector>

#include "../core/ray.h"
#include "../core/scene.h"

class Scene;

class Shader
{
public:
    Shader();
    Shader(Vector3D bgColor_);
	Shader(Vector3D bgColor_, size_t nSamplesPP_);

	virtual void preprocess(Scene &scene);

	virtual void postprocess(Scene &scene);

	virtual void render(Scene &scene);

	virtual Vector3D computeColor(const Ray &r, Scene &scene) const = 0;

    Vector3D bgColor;
	size_t nSamplesPP; // number of primary rays per pixel
};

#endif // SHADER_H
