#include "shape.h"

Shape::Shape(const Matrix4x4 &t_, Material *material_)
{
    objectToWorld = t_;
    objectToWorld.inverse(worldToObject);
    material = material_;
	isEmissive = false;
}

Vector3D Shape::getEmission() const {
	if (isEmissive)
		return emission;
	else
		return Vector3D(0);
}

bool Shape::isEmissiveShape() const {
	return isEmissive;
}

void Shape::setEmission(const Vector3D &emission_){
	isEmissive = true;
	emission = emission_;
}

const Material& Shape::getMaterial() const
{
    return *material;
}

void Shape::getTextureCoordinates(const Vector3D &pointWorld, double &uOut, double &vOut) const
{
    uOut = 0.0;
    vOut = 0.0;
}
